package org.gcube.informationsystem.types.reference;

import java.util.Set;

import org.gcube.informationsystem.base.reference.IdentifiableElement;
import org.gcube.informationsystem.types.annotations.Abstract;
import org.gcube.informationsystem.types.reference.properties.PropertyDefinition;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

@Abstract
@JsonIgnoreProperties(ignoreUnknown=true)
//@JsonDeserialize(as=TypeImpl.class) Do not uncomment to manage subclasses
public interface Type extends IdentifiableElement {
	
	public static final String NAME = "Type"; //Type.class.getSimpleName();
	
	public static final String NAME_PROPERTY = "name";
	public static final String DESCRIPTION_PROPERTY = "description";
	public static final String ABSTRACT_PROPERTY = "abstract";
	public static final String TYPE_SUPERCLASSES_PROPERTY = "superClasses";
	public static final String PROPERTIES_PROPERTY = "properties";
	
	public String getName();
	
	public String getDescription();
	
	public boolean isAbstract();

	public Set<String> getSuperClasses();
	
	public Set<PropertyDefinition> getProperties();
	
}
